#include "mns.h"

#define RPCMAX 7

int *rpcscan(struct in_addr);

const static char *rpcservs[RPCMAX] =
   { "mountd", "rstatd", "nlockmgr", "status", "nisd", "ttdb", "autofsd" };

struct node *rpc (struct in_addr target, struct node *walk) {

  int i = 0;
  int *rpcl;
  
  if((rpcl = rpcscan(target)) == NULL) return walk;
  stralloc (walk, "\n   RPC ->");
  for(i = 0; i < RPCMAX; i++)
     if(rpcl[i]) stralloc(walk, rpcservs[i]);

  return walk;
}

int *rpcscan(struct in_addr target) {
   SAin svraddr;
   struct pmaplist *head = NULL;
   int sockett = RPC_ANYSOCK;
   struct timeval timeout;
   register CLIENT *client;
   struct rpcent *rpc;
   int *rpcchkd;
   int i;
   
   svraddr.sin_addr = target;
   svraddr.sin_family = AF_INET;
   svraddr.sin_port = htons (PMAPPORT);
   timeout.tv_sec = TIMEOUT << 1;
   timeout.tv_usec = 0;

   signal (SIGALRM, &sighandler);
   /* cause clnttcp_create uses connect() */
   alarm (TIMEOUT << 1);

   if((client = clnttcp_create(&svraddr, PMAPPROG,
                               PMAPVERS, &sockett,
                               50, 500)) == NULL) {
      alarm(0);
      return NULL;
   }
   alarm (0);

   if(clnt_call(client, PMAPPROC_DUMP, (xdrproc_t)xdr_void, NULL,
	        (xdrproc_t)xdr_pmaplist, &head, timeout) != RPC_SUCCESS)
      return NULL;

  if (head == NULL) return NULL;

  rpcchkd = calloc(sizeof(int) * RPCMAX, 1);
  
  for (; head != NULL; head = head->pml_next)
     if((rpc = getrpcbynumber(head->pml_map.pm_prog)))
        for(i = 0; i < RPCMAX; i++)
           if(!strcmp(rpcservs[i], rpc->r_name))
              rpcchkd[i] = 1;

  return rpcchkd;
}
